/*
 * Copyright (C) 2001-2012 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#pragma once

#include "FastAlloc.h"
#include "User.h"
#include "CID.h"

namespace dcpp {

class FavoriteUser : public Flags {
public:
    FavoriteUser(const UserPtr& user_, const string& nick_, const string& hubUrl_) : user(user_), nick(nick_), url(hubUrl_), lastSeen(0) { }

    enum Flags {
        FLAG_GRANTSLOT = 1 << 0
    };

    UserPtr& getUser() { return user; }

    void update(const OnlineUser& info);

    GETSET(UserPtr, user, User);
    GETSET(string, nick, Nick);
    GETSET(string, url, Url);
    GETSET(time_t, lastSeen, LastSeen);
    GETSET(string, description, Description);
};

} // namespace dcpp
